"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _WebGLRenderingContext = _interopRequireDefault(require("./WebGLRenderingContext"));

var _CanvasRenderingContext2D = _interopRequireDefault(require("./CanvasRenderingContext2D"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var HTMLCanvasElement =
/*#__PURE__*/
function () {
  function HTMLCanvasElement(width, height) {
    _classCallCheck(this, HTMLCanvasElement);

    _defineProperty(this, "generatedContexts", new WeakMap());

    this.width = width || 100;
    this.height = height || 100;
    this.getContext = jest.fn(this.getContext.bind(this));
    this.toBlob = jest.fn(this.toBlob.bind(this));
    this.toDataURL = jest.fn(this.toDataURL.bind(this));
  }

  _createClass(HTMLCanvasElement, [{
    key: "getContext",
    value: function getContext(type) {
      /**
       * Contexts must be indempotent. Once they are generated, they should be returned when
       * getContext() is called on the same canvas object multiple times.
       */
      if (type === '2d') {
        if (this.generatedContexts.has(this)) return this.generatedContexts.get(this);
        var ctx = new _CanvasRenderingContext2D["default"](this);
        this.generatedContexts.set(this, ctx);
        return ctx;
      } else if (type === 'webgl' || type === 'experimental-webgl') {
        if (this.generatedContexts.has(this)) return this.generatedContexts.get(this);

        var _ctx = new _WebGLRenderingContext["default"](this);

        this.generatedContexts.set(this, _ctx);
        return _ctx;
      }

      try {
        if (!this.dataset.internalRequireTest) require('canvas');
      } catch (_unused) {
        return null;
      }
    }
    /**
     * This function technically throws SecurityError at runtime, but it cannot be mocked, because
     * we don't know if the canvas is tainted. These kinds of errors will be silent.
     */

  }, {
    key: "toBlob",
    value: function toBlob(callback, mimetype) {
      if (arguments.length < 1) throw new TypeError('Failed to execute \'toBlob\' on \'HTMLCanvasElement\': 1 argument required, but only 0 present.');
      if (typeof callback !== 'function') throw new TypeError('Failed to execute \'toBlob\' on \'HTMLCanvasElement\': The callback provided as parameter 1 is not a function.');
      /**
       * Mime type must be image/jpeg or image/webp exactly for the browser to accept it, otherwise
       * it's image/png.
       */

      switch (mimetype) {
        case 'image/webp':
          break;

        case 'image/jpeg':
          break;

        default:
          mimetype = 'image/png';
      }
      /**
       * This section creates a blob of size width * height * 4. This is not actually valid, because
       * jpeg size is variable, and so is png. TODO: Is there a better way to do this?
       */


      var length = this.width * this.height * 4;
      var data = new Uint8Array(length);
      var blob = new window.Blob([data], {
        type: mimetype
      });
      setTimeout(function () {
        return callback(blob);
      }, 0);
    }
    /**
     * This section creates a dataurl with a validated mime type. This is not actually valid, because
     * jpeg size is variable, and so is png. TODO: Is there a better way to do this?
     */

  }, {
    key: "toDataURL",
    value: function toDataURL(type, encoderOptions) {
      switch (type) {
        case 'image/jpeg':
          break;

        case 'image/webp':
          break;

        default:
          type = 'image/png';
      }
      /**
       * This is the smallest valid data url I could generate.
       */


      return 'data:' + type + ';base64,00';
    }
  }]);

  return HTMLCanvasElement;
}();

exports["default"] = HTMLCanvasElement;